[<prev] [next>] [<thread-prev] [thread-next>] [day] [month] [year] [list]
Message-ID: <20220930063527.108389-3-zhaogongyi@huawei.com>
Date: Fri, 30 Sep 2022 14:35:25 +0800
From: Zhao Gongyi <zhaogongyi@...wei.com>
To: <linux-doc@...r.kernel.org>, <linux-kernel@...r.kernel.org>,
<linux-mm@...ck.org>, <linux-kselftest@...r.kernel.org>
CC: <akinobu.mita@...il.com>, <corbet@....net>, <david@...hat.com>,
<osalvador@...e.de>, <shuah@...nel.org>, <zhaogongyi@...wei.com>
Subject: [PATCH -next v5 2/4] selftests/memory-hotplug: Restore memory before exit
Some momory will be left in offline state when calling
offline_memory_expect_fail() failed. Restore it before exit.
Signed-off-by: Zhao Gongyi <zhaogongyi@...wei.com>
---
.../memory-hotplug/mem-on-off-test.sh | 21 ++++++++++++++-----
1 file changed, 16 insertions(+), 5 deletions(-)
diff --git a/tools/testing/selftests/memory-hotplug/mem-on-off-test.sh b/tools/testing/selftests/memory-hotplug/mem-on-off-test.sh
index 1d87611a7d52..91a7457616bb 100755
--- a/tools/testing/selftests/memory-hotplug/mem-on-off-test.sh
+++ b/tools/testing/selftests/memory-hotplug/mem-on-off-test.sh
@@ -134,6 +134,16 @@ offline_memory_expect_fail()
return 0
}
+online_all_offline_memory()
+{
+ for memory in `hotpluggable_offline_memory`; do
+ if ! online_memory_expect_success $memory; then
+ echo "$FUNCNAME $memory: unexpected fail" >&2
+ retval=1
+ fi
+ done
+}
+
error=-12
priority=0
# Run with default of ratio=2 for Kselftest run
@@ -275,11 +285,7 @@ done
# Online all hot-pluggable memory
#
echo 0 > $NOTIFIER_ERR_INJECT_DIR/actions/MEM_GOING_ONLINE/error
-for memory in `hotpluggable_offline_memory`; do
- if ! online_memory_expect_success $memory; then
- retval=1
- fi
-done
+online_all_offline_memory
#
# Test memory hot-remove error handling (online => offline)
@@ -296,4 +302,9 @@ done
echo 0 > $NOTIFIER_ERR_INJECT_DIR/actions/MEM_GOING_OFFLINE/error
/sbin/modprobe -q -r memory-notifier-error-inject
+#
+# Restore memory before exit
+#
+online_all_offline_memory
+
exit $retval
--
2.17.1
Powered by blists - more mailing lists